#include <stdio.h>
#include <conio.h>

extern void decompress (long,char*,char*,char*);
void process (char ** argv);
void save_to_disk (void);

long CRC;
long offset;
long compressed_size;
long size;
char *compr;
char *uncompr;
char *buffer;
char *headers;
long number_of_files;
FILE *source,*target;
long i;
char * file_crc;


void main (int argc, char **argv)

{

clrscr();

printf ("Wing Commander Prophecy - Secret Operations File Extractor. Protected mode.\n\n");

if (argc!=2)
        {
        printf ("Usage is: wcso-rip <tre-file>\n");
        printf ("This program will extract ALL the files within the TRE\n(it still has trouble uncompressing files >3mb)\n\n");
        printf ("FAST extraction (no slow disk swaps)\n");
        printf ("Also Extracts files with Zero Compression.\n");
        printf ("Created by Mario \"HCl\" Brito\nmop23404@mail.telepac.pt\nhttp://www.geocities.com/Area51/Vault/6483/WC.HTM\n");
        return;
        }

compr=(char *) malloc (1500000);
uncompr=(char *) malloc (3000000);
buffer=(char *) malloc (10000);
headers=(char *) malloc (1500000);

if (compr==NULL || uncompr==NULL || buffer==NULL || headers==NULL)

        {
        printf ("ERROR allocating memory! -- %p %p %p %p -- Exiting...\n",compr,uncompr,buffer,headers);
        printf ("Check the properties of your DOS Window and set the DPMI memory to the maximum.\n\n");
        return;
        }

process (argv);


free (compr);
free (uncompr);
free (buffer);
}



void process (char ** argv)
{

source=fopen (argv[1],"rb");
if (source==NULL)
        {
        printf ("ERROR opening file.\n");
        return;
        }
fread (&number_of_files,4,1,source);
fseek (source,16L,SEEK_SET);
fread (headers,272*number_of_files,1,source);

// Here Cometh the Main LOOP
for (i=0;i<number_of_files;++i)
        {
        file_crc = (headers+(272*i));
        CRC = * (long *)(file_crc);
        size = * (long *)(file_crc+4);
        offset = * (long *)(file_crc+8);
        compressed_size = * (long *)(file_crc+12);
                
        printf ("File %ld - CRC: %lX - Size: %ld - Offset %ld - Compression: ",i,CRC,size,offset);
        if (compressed_size == 0)
                {
                printf ("N/A\n");
                fseek (source,offset,SEEK_SET);
                fread (uncompr,size,1,source);
                save_to_disk ();
                }
        else
                {
                printf ("%ld\n",compressed_size);
                fseek (source,offset,SEEK_SET);
                fread (compr,compressed_size,1,source);
                decompress(size,compr,uncompr,buffer);  // The work horse
                save_to_disk ();
                }
        }
fclose (source);
}

void save_to_disk (void)
{
int n,m,last=0,number_of_directories=0;
char * fcc=file_crc+16;
char file[200];
for (n=0;n<200;++n)
        {
        if ((*(fcc+n))=='\\')
                {
                *(fcc+n)=0;
                for (m=0;m<200;m++)
                        {
                        file[m]=*(fcc+last+m);
                        if (file[m]==0) break;
                        }
                mkdir (file);
                chdir (file);
                number_of_directories++;
                last=n+1;
                *(fcc+n)='\\';
                }

        if ((*(fcc+n))=='.')
                {
                if ((target=fopen ((fcc+last),"wb"))==NULL)
                        {
                        printf ("ERROR creating file. Wtf?\n");
                        getch();
                        return;
                        }
                fwrite (uncompr,size,1,target);
                fclose (target);
                for (m=0;m<number_of_directories;m++)
                        chdir ("..");

                return;

                }

        }


}

